<?php 
define('SLA_SelectProducts',        1); //option, select product or department in SLA specification

if (!get_magic_quotes_gpc()) {
	function traverse (&$arr) {
		if (!is_array($arr))
			return;

		foreach ($arr as $key => $val) {
			if (is_array($arr[$key]))
				traverse($arr[$key]);
			else
				$arr[$key] = addslashes($arr[$key]);
		}
   }
   $gpc = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
   traverse($gpc);
}

if(isset($_SESSION["sid"]) && isset($conn)) {
	$tz=dlookup("tz","site","sid=".$_SESSION['sid']."")*60*60;
	$prod_id=dlookup("prod_id","site","sid=".$_SESSION['sid']."");if(nz($prod_id,"")=="") $prod_id="4";
}

function strtotime2($s){
	global $tz;
	return strtotime($s)+$tz;
}
function time2(){
	global $tz;
	return time()+$tz;
}

function paginator($page,$pgcnt,$cnt,$onclick,$rec="records", $permalink="#"){
	if($cnt>$pgcnt){
		//strreplace("%PAGE%",$page,$onclick);
		$pagemax=(int)(($cnt+($pgcnt-1))/$pgcnt);
		?>
		<div ><table class="paginator"><tr>
		<td><?php echo __("Page")?></td> 
		<?php if($page>6 && $pagemax>10){?><td><a class="cmdlink" onclick="<?php echo str_replace("%PAGE%",max(1,$page-10),$onclick)?>;return false;" href="#">&laquo;</a></td><?php }?>
		<?php for($f=(($pagemax>10)?(max(1,$page-5)):1);$f<=min(max(1,$page-5)+9,($pagemax));$f++) {if($f==$page) echo "<td class=\"x\">".$f."</td>"; else {echo "<td><a class=\"cmdlink\" onclick=\"".str_replace("%PAGE%",$f,$onclick).";return false;\" href=\"".str_replace("%PAGE%",$f,$permalink)."\">$f</a>";echo " </td>";}} 
		  if($f<$pagemax){?><td><a class="cmdlink" onclick="<?php echo str_replace("%PAGE%",min($pagemax,$page+10),$onclick)?>;return false;" href="#">&raquo;</a></td><?php }?> 
		<td>(<?php echo $cnt?> <?php echo $rec?>)</td>
		</tr></table></div>
		<?php
	}
}

function apply_SLA_rule($id){
	global $sid,$uid;
	$t=dlookup_row("select * from reg where sid=$sid and ID='$id'");
	if(!SLA_SelectProducts) $t['product']=$t['department'];//option, we are using departments in SLA rules instead of products
	if (!strlen($t["product"])) $t['product']="-"; //not set
	if (!strlen($t["type"])) $t["type"]="-"; //not set
	if (!strlen($t["group"])) $t["group"]="-"; //not set
	//if(isset($_REQUEST["uorg"])) $uorg=$_REQUEST["uorg"]; else $uorg=dlookup("org","usr","sid=$sid and uname='$t[uid]'");
	$uorg=$t["org"];if($uorg==-1) $uorg=0; //self-registered users
	// prod type group
	while(1){
		$r=dlookup_row("select * from sla where sid=$sid and org=$uorg and prod='".$t['product']."' and `group`='".$t['ticket_group']."'");
		if ($r===null) $r=dlookup_row("select * from sla where sid=$sid and org=$uorg and prod='".$t['product']."' and `group`='".$t['ticket_type']."'");
		if ($r===null) $r=dlookup_row("select * from sla where sid=$sid and org=$uorg and prod='*' and `group`='".$t['ticket_group']."'");
		if ($r===null) $r=dlookup_row("select * from sla where sid=$sid and org=$uorg and prod='*' and `group`='".$t['ticket_type']."'");
		if ($r===null) $r=dlookup_row("select * from sla where sid=$sid and org=$uorg and prod='".$t['product']."' and `group`='*'");
		if ($r===null) $r=dlookup_row("select * from sla where sid=$sid and org=$uorg and prod='*' and `group`='*'");
		if ($r===null && $uorg!=0) $uorg=0; else break;
	}
	if ($r===null){
		//if SLA rule is not found, and department is set, assign a ticket to department manager
		if(strlen($t['department']) && !strlen($t['assigned_to'])){//don't re-assign if already assigned
			//assign to department manager, or a specialist if manager is not defined
			$assign_to=dlookup("mgr","dep","sid=$sid and n='".$t['department']."'",dlookup("uname","usr","sid=$sid and department='".$t['department']."'"));
			if($assign_to!=null) 
				mysql_query("update reg set modified_by='$uid',time2=now(),".(($t['cur_status']==0)?"cur_status=1,":"")."assigned_to='$assign_to' where sid=$sid and ID='$id'") or die("mysql_error()");
			return 1;
		}
		return 0;
	}
	else{
		if(substr($r['assign_to'],0,1)=="("){ //department
			$dep=substr($r['assign_to'],1,strlen($r['assign_to'])-2);
			$na=dlookup_row("select assigned_to from reg where sid=$sid and cur_status<5 and assigned_to<>'' group by assigned_to order by count(*) limit 1");
			$r['assign_to']=$na["assigned_to"];
			if($r['assign_to']==null || $r['assign_to']=="") $r['assign_to']=dlookup("uname","usr","sid=$sid and department='$dep'");
			if($r['assign_to']==null || $r['assign_to']=="") $r['assign_to']=$uid;//fallback to current user
		}
		
		readOpts();
		$hourstodedline=0;$c=0;
		while($c<$r['deadline'] && $hourstodedline<365*24) {$hourstodedline++;if(isWorkingHour(time()+(3600*$hourstodedline))) $c++;}

		if(strlen($t['assigned_to'])) $r['assigned_to']=$t['assigned_to'];//don't re-assign if already assigned
		
		mysql_query("update reg set modified_by='$uid',sla_id=".$r['id'].",time2=now(),".(($t['cur_status']==0)?"cur_status=1,":"")."priority=".$r['priority'].",due_to=date_add(time1,interval $hourstodedline hour),assigned_to='".$r['assign_to']."' where sid=$sid and ID='$id'") or die("mysql_error()");
		mysql_query("insert into reg_log(sid,tid,uid,note,time1,private) values($sid,'$id','system','".__("classified by SLA rule")."',NOW(),0)");
		return 1;
	}
}

function isWorkingHour($time){
	$w=date('w',$time);
	if($w==0) $w=7;//sunday
	$w-=1;//0=monday, 6=sunday
	
	$h=date('G',$time);
	return substr($GLOBALS['optWH'],$h*7+$w,1);
}

function notify_closed_ticket($id){
	global $sid,$uid;
	$t=dlookup_row("select * from reg where sid=$sid and ID='$id'");
	$addr=dlookup("addr","usr","sid=$sid and uname='".$t['uid']."'",$t['uid']);
	if (strlen($addr) ){
		$reply=dlookup("closed_mail","site","sid=$sid");
		$reply=dlookup("trans","trans","sid=$sid and type=99 and id=5 and lang='".$t['lang']."'",$reply);
		if(trim($reply)!='') {
			$reply=str_replace("%TICKET_ID%",$id,$reply);
			$reply=str_replace("%TICKET_TEXT%",$t['description'],$reply);
			$reply=str_replace("%TICKET_SUBJECT%",$t['subject'],$reply);
			$reply=str_replace("%TICKET_STATUS%",get_status($t['cur_status']),$reply);
			$pp=base64_encode("a=6&email=".urlencode($addr)."&sid=$sid&id=$id");
			$ticket_url=trim(dlookup("app_url","site","sid=$sid"),"/")."/index.php?pp=$pp";
			$reply=str_replace("%TICKET_URL%",$ticket_url,$reply);

			$subject=$t['subject'];
			if(substr($reply,0,1)==':'){
				$subject=substr($reply,1,strpos($reply,"\n")-1);
				$reply=substr($reply,strpos($reply,"\n"));
			}
			
			send_mail($addr,$subject." [$id]",$reply);
		}
	}
	

}

function notify_new_ticket($id,$reply_to=""){
	global $sid,$uid;
	$t=dlookup_row("select * from reg where sid=$sid and ID='$id'");
	if($t["assigned_to"]!="" && $uid!=$t["assigned_to"]){ //don't send notification email if $uid is entered the ticket
		$e=dlookup_row("select * from usr where sid=$sid and uname='".$t['assigned_to']."'");
		
		$reply_to=dlookup("addr","email","sid=$sid");
		if (strlen($e['addr']) && $e["nu"]){ //email-notification option
			$reply=dlookup("assigned_mail","site","sid=$sid");
			$reply=dlookup("trans","trans","sid=$sid and type=99 and id=6 and lang='".$e['ulang']."'",$reply);
			
			if(trim($reply)=='') $reply="Ticket %TICKET_ID% has been assigned to you.<hr>%TICKET_TEXT%";
			$reply=str_replace("%TICKET_ID%",$id,$reply);
			$reply=str_replace("%TICKET_TEXT%",$t['description'],$reply);
			$reply=str_replace("%TICKET_SUBJECT%",$t['subject'],$reply);
			$reply=str_replace("%TICKET_STATUS%",get_status($t['cur_status']),$reply);

			$subject=$t['subject'];
			if(substr($reply,0,1)==':'){
				$subject=substr($reply,1,strpos($reply,"\n")-1);
				$reply=substr($reply,strpos($reply,"\n"));
			}
		
			send_mail($e['addr'],$subject." [$id]",$reply,"","",$reply_to);
		}
	}
}

function is_image($n){
	if(strlen($n)<4) return false;
	$n=strtolower($n);
	if(substr($n,-4)==".jpg") return true;
	if(substr($n,-4)==".gif") return true;
	if(substr($n,-4)==".png") return true;
	return false;
}

function fr_txt2html($msg){
	global $ESP_path;
	$msg=txt2html($msg);
	
	$msg=str_replace("[QUOTE]","<div class=\"quoted_text\">",$msg);
	$msg=str_replace("[/QUOTE]","</div>",$msg);
	$msg=preg_replace("/(\[)(\/?)(b|u|i|strike|sup|sub)(\])/e", "'<\\2\\3>'", $msg);

    // match [url]
    $msg= preg_replace_callback("/\[url\]([^\[]*)\[\/url\]/i", create_function('$matches','return " <a href=\"".((strpos($matches[1],"://")===false)?"http://":"")."".$matches[1]."\">".$matches[1]."</a>";'), $msg);
    // match [img]
    $msg= preg_replace_callback("/\[img\]([^\[]*)\[\/img\]/i", create_function('$matches','return " <img src=\"".((strpos($matches[1],"://")===false)?"http://":"")."".$matches[1]."\" />";'), $msg);
    // match [smile_image]
    $msg= preg_replace_callback("/\[([a-zA-Z0-9\_\.\-]*)\]/i", create_function('$matches','if (!file_exists("ico/emoticon_".$matches[1].".gif")) return $matches[0]; else return " <img src=\"'.$ESP_path.'ico/emoticon_".$matches[1].".gif\"/>";'), $msg);
	return $msg;
}


function findval($a,$k){
	foreach($a as $x=>$v){
		if($k==$x) return $v;
	}
	foreach($a as $x=>$v){
		if(is_array($v)) return findval($v,$k);
	}
	return $a;
}

function splitemail($e){
	for($f=0;$f<strlen($e) && substr($e,$f,1)!='<';$f++) ;
	if($f==strlen($e)) return trim(str_replace('"',"",str_replace("'","",$e)));	
	for($t=$f+1;$t<strlen($e) && substr($e,$t,1)!='>';$t++) ;
	return trim(str_replace('"',"",str_replace("'","",substr($e,$f+1,$t-($f+1)))));	

	//$a=explode("<",$e);	if(count($a)>1) {$b=explode(">",$a[1]);return $b[0];}	else return $e;
}

function formatHM($m){
	return floor($m/60).":".($m%60);
}

function getdir($f){
	$directory = $f; 
	$files = array(); 
	
	if($handle = opendir($directory)) 
	{ 
		while(($filename = readdir($handle)) !== false) 
			if($filename !== '.' && $filename !== '..') {
				$files[] = array("name"=>$filename,"size"=>filesize($f."/".$filename), "date"=>filemtime($f."/".$filename));
			}
		closedir($handle); 
	}
	return $files;
}

function is_demo(){
	global $uid,$sid;
	return file_exists("demo.html") && $uid!="ado" && ($sid==1 || $sid==5 || $sid==6);
}

function getsig($uid){
	global $sid;
	return "\n".dlookup("signature","usr","sid=$sid and uname='$uid'");
}

function usrlogout(){
	$sid=$_SESSION["sid"];
	$uid=$_SESSION["uid"];
	if($_SESSION["was_in_forum"]=="1") {
		if (strlen($uid)) mysql_query("update usr set fr_time = now() where sid=$sid and uname='$uid'");
	}
	
	if($_SESSION["was_in_nw"]=="1") {
		if (strlen($uid)) mysql_query("update usr set nw_time=now() where sid=$sid and uname='$uid'") or die("mysql_error()");
	}
	if (strlen($uid)) mysql_query("update usr set reg_time=now() where sid=$sid and uname='$uid'") or die("mysql_error()");

}

//date_default_timezone_set("UTC");

function strip_selected_tags($text, $tags = array())
{
   $args = func_get_args();
   $text = array_shift($args);
   $tags = func_num_args() > 2 ? array_diff($args,array($text))  : (array)$tags;
   foreach ($tags as $tag){
	   if( preg_match_all( '/<'.$tag.'[^>]*>([^<]*)<\/'.$tag.'>/iu', $text, $found) ){
		   $text = str_replace($found[0],$found[1],$text);
	   }
   }
   return preg_replace( '/(<('.join('|',$tags).')(\\n|\\r|.)*\/>)/iu', '', $text);
}
   
function strip_tags_attributes($sSource, $aAllowedTags = array('<p>','<a>','<br>','<b>','<i>','<u>','<ul>','li'), $aDisabledAttributes = array('onabort', 'onblue', 'onchange', 'onclick', 'ondblclick', 'onerror', 'onfocus', 'onkeydown', 'onkeyup', 'onload', 'onmousedown', 'onmousemove', 'onmouseover', 'onmouseup', 'onreset', 'onresize', 'onselect', 'onsubmit', 'onunload'))
{
	if (empty($aDisabledAttributes)) return strip_tags($sSource, implode('', $aAllowedTags));

	return preg_replace('/<(.*?)>/ie', "'<' . preg_replace(array('/javascript:[^\"\']*/i', '/(" . implode('|', $aDisabledAttributes) . ")[ \\t\\n]*=[ \\t\\n]*[\"\'][^\"\']*[\"\']/i', '/\s+/'), array('', '', ' '), stripslashes('\\1')) . '>'", strip_tags($sSource, implode('', $aAllowedTags)));
}

function br2nl($text)
{
	$tmp=preg_replace('/<br\\\\s*?\\/??>/i', "\\n", $text);
	return preg_replace('/<\\/p>/i', "\\n", $tmp);
}

function html2txt($document){
	$search = array('@<script[^>]*?>.*?</script>@si',  // Strip out javascript
				  '@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
				  '@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags
				  '@<![\s\S]*?--[ \t\n\r]*>@'        // Strip multi-line comments including CDATA
	);
	$text = str_replace("\n","",$text);
	$text = str_replace("\r","",$text);
	$text = br2nl($text);
	$text = preg_replace($search, '', $document);
	$text = html_entity_decode($text,ENT_COMPAT,"UTF-8");//str_replace("&nbsp;"," ",$text);
	return $text;
}

function txt2html($t){
	return nl2br(htmlentities($t,ENT_COMPAT,"UTF-8"));
}

function send_mail($to,$subject, $body, $from="", $from_addr="",$reply_to="",$fn1="",$cc="",$bcc="",$is_html=true){
	global $sid,$uid;
	$mail = new PHPMailer();

	$h=dlookup("smtp_host","site","sid=$sid");
	if (strtolower($h)=="sendmail"){
		$mail->IsSendmail();                                      // set mailer to use sendmail
	}
	else if (strtolower($h)=="mail()"){
		$mail->IsMail();                                      // set mailer to use mail()
	}
	else{
		$mail->IsSMTP();                                      // set mailer to use SMTP
		$mail->Host = dlookup("smtp_host","site","sid=$sid");//"smtp1.example.com;smtp2.example.com";  // specify main and backup server
		$mail->Username = dlookup("smtp_username","site","sid=$sid");  // SMTP username
		$mail->Password = dlookup("smtp_pwd","site","sid=$sid"); // SMTP password
	}
	if($mail->Username=="") $mail->SMTPAuth = false; else $mail->SMTPAuth = true;
	
	
	$mail->From = dlookup("sender_addr","site","sid=$sid");
	$mail->FromName = dlookup("sender_name","site","sid=$sid");
	if($from!="") $mail->FromName = $from;
	if($from_addr!="") $mail->From = $from_addr;
	
	
	$toa=explode(";",$to);	foreach($toa as $to1)		$mail->AddAddress(trim($to1));                  // name is optional
	
	if(strlen($cc)) {$cca=explode(";",$cc);	foreach($cca as $cc1)		$mail->AddCC(trim($cc1));}                  // name is optional
	if(strlen($bcc)) {$bcca=explode(";",$bcc);	foreach($bcca as $bcc1)		$mail->AddBCC(trim($bcc1));}                  // name is optional
	
	if($reply_to!="") $mail->AddReplyTo($reply_to);
	else if($from_addr!="") $mail->AddReplyTo($from_addr);
	else $mail->AddReplyTo(dlookup("replyto_addr","site","sid=$sid"));
	
	//$mail->WordWrap = 50;                                 // set word wrap to 50 characters
	if(strlen($fn1)) $mail->AddAttachment($fn1);    // , "new.jpg" optional name
	$mail->IsHTML($is_html);                                  // set email format to HTML
	$mail->CharSet="utf-8";


	$mail->Subject = $subject;
	//free $body.=d("PGJyPjxicj5TZW50IHVzaW5nIEVTQ09OIFN1cHBvcnRQb3J0YWwsIHRoZSBjb21wbGV0ZSBoZWxwZGVzayBzb2x1dGlvbi48YnI+PGJyPg==");
	$mail->Body    = $body;
	
	if($is_html) $mail->AltBody = html2txt($body);//non-HTML body
	
	$ret=$mail->Send();
	$GLOBALS['send_mail_error']=$mail->ErrorInfo;

	if(!$ret){
		mysql_query("insert into `log`(sid,uid,ip_addr,type,desc1) values($sid,'$uid','".$_SERVER['REMOTE_ADDR']."',16,'FAILED mail sending to $to $cc $bcc - ".$GLOBALS['send_mail_error']."(".addslashes($subject).")"."')");
	}
	else{
		mysql_query("insert into `log`(sid,uid,ip_addr,type,desc1) values($sid,'$uid','".$_SERVER['REMOTE_ADDR']."',16,'mail sent to $to $cc $bcc "."(".addslashes($subject).")"."')");
	}
	
	return $ret;
}


function get_recipients($sid,$ml_id){
	$r="";
	$res=mysql_query("select * from ml_usr where sid=$sid and m_id=$ml_id");
	if ($res==null) return "";
	if (mysql_num_rows($res) >0) {
		while($row = mysql_fetch_assoc($res)) {
			$r.=str_replace(";"," ",$row['name'])."<".$row["addr"].">; ";
		}
	}
	mysql_free_result($res);
	if (strlen($r)) $r=substr($r,0,strlen($r)-2);
	return $r;
}


function formatKb($s){
	if ($s>1024*1024) return round($s/(1024*1024),2)."Mb";
	if ($s>1024) return round($s/(1024),2)."Kb";
	return $s."B";
}

function get_renderStatus($i){
	global $ESP_path;
	$r=get_status($i);
	
	if ($i==0) return "<img alt=\"$r\" src=\"".$ESP_path."ico/new.gif\"/>";
	if ($i==1) return "<img alt=\"$r\" src=\"".$ESP_path."ico/new.gif\"/>";
	if ($i==2) return "<img alt=\"$r\" src=\"".$ESP_path."ico/new.gif\"/>";
	if ($i==3) return "<img alt=\"$r\" src=\"".$ESP_path."ico/wrench.gif\"/>";
	if ($i==4) return "<img alt=\"$r\" src=\"".$ESP_path."ico/status_away.gif\"/>";
	if ($i==5) return "<img alt=\"$r\" src=\"".$ESP_path."ico/tick.gif\"/>";//"Solved";
	if ($i==6) return "<img alt=\"$r\" src=\"".$ESP_path."ico/book.gif\"/>";//"Closed";
	if ($i==7) return "<img alt=\"$r\" src=\"".$ESP_path."ico/thumb_down.gif\"/>";//"Rejected";
	return $r;
}

function get_status($i){
	if ($i==0) return __("status0","New");
	if ($i==1) return __("status1","Classified");
	if ($i==2) return __("status2","Open");//classified, prioritized
	if ($i==3) return __("status3","Work in progress");
	if ($i==4) return __("status4","Waiting");
	if ($i==5) return __("status5","Solved");
	if ($i==6) return __("status6","Closed");
	if ($i==7) return __("status7","Rejected");
	return $i;
}

function get_usrlvl($i){
	if ($i==1) return __("End user");
	if ($i==2) return __("Manager");
	if ($i==3) return __("Support engineer");
	if ($i==4) return __("Support manager");
	if ($i==5) return __("Superuser");
	return "Undefined";
}

function get_renderPriority($i){
	$r=get_priority($i);

	if ($i==0) return "<span title=\"$r\" style=\"line-height:8px;font-size:8px;width:8px;height:8px;background-color:silver;\">&nbsp;&nbsp;&nbsp;</span>";
	if ($i==1) return "<span title=\"$r\" style=\"line-height:8px;font-size:8px;width:8px;height:8px;background-color:green;\">&nbsp;&nbsp;&nbsp;</span>";
	if ($i==2) return "<span title=\"$r\" style=\"line-height:8px;font-size:8px;width:8px;height:8px;background-color:orange;\">&nbsp;&nbsp;&nbsp;</span>";
	if ($i==3) return "<span title=\"$r\" style=\"line-height:8px;font-size:8px;width:8px;height:8px;background-color:red;\">&nbsp;&nbsp;&nbsp;</span>";

	if ($i==0) return "<font color=gray>$r</font>";
	if ($i==1) return "<font colot=black>$r</font>";
	if ($i==2) return "<font color=orange>$r</font>";
	if ($i==3) return "<font color=red>$r</font>";
	return $r;
}

function get_priority($i){
	if ($i==0) return __("priority0","Low");
	if ($i==1) return __("priority1","Normal");
	if ($i==2) return __("priority2","High");
	if ($i==3) return __("priority3","Urgent");
	return "Undefined";
}

function include_css(){
	global $sid,$is_admin,$ulvl,$org;
	if(!isset($_SESSION['visual_theme'])) $_SESSION['visual_theme']=dlookup("visual_theme","site","sid=$sid");
	$visual_theme=$_SESSION['visual_theme'];
?>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" >
<?php if($_SESSION['lang']=="Arabic") {?><style>body {direction:rtl;}</style><?php }?>
<?php if($is_admin || $ulvl==2){?>
<link rel="stylesheet" type="text/css" href="js/resources/css/ext-all.css" />
<link rel="stylesheet" type="text/css" href="js/resources/css/xtheme-aero.css" />
<?php }?>
<?php if(!defined('_VALID_MOS')){?>
	<link rel="stylesheet" type="text/css" href="template_css.css" />
<?php }?>
<link rel="stylesheet" type="text/css" href="main.css" />
<?php if (file_exists("uploads/$sid.main.css")){?><link rel="stylesheet" type="text/css" href="dl.php?css=<?php echo $sid?>" /><?php }?>
<?php
}

function utf8Urldecode($value)
{
/*
   $decodedStr = "";
   $pos = 0;
   $source=$value;
   $len = strlen ($source);
   while ($pos < $len) {
       $charAt = substr ($source, $pos, 1);
       if ($charAt == '%') {
           $pos++;
           $charAt = substr ($source, $pos, 1);
           if ($charAt == 'u') {
               // we got a unicode character
               $pos++;
               $unicodeHexVal = substr ($source, $pos, 4);
               $unicode = hexdec ($unicodeHexVal);
               $entity = "&#". $unicode . ';';
               $decodedStr .= utf8_encode ($entity);
               $pos += 4;
           }
           else {
               // we have an escaped ascii character
               $hexVal = substr ($source, $pos, 2);
               $decodedStr .= chr (hexdec ($hexVal));
               $pos += 2;
           }
       } else {
           $decodedStr .= $charAt;
           $pos++;
       }
   }
   $value=$decodedStr;
*/
	$value = rawurldecode($value);//preg_replace('/%u([0-9a-f]{2})/ie', 'chr(hexdec(substr($1,1)))', (string) $value);
    return $value;
}

function nz($v,$n){
	if($v==null) return $n; else return $v;
}

function dlookup($f,$t,$w, $def=null)
{
	$res=mysql_query("select $f from $t where $w") or print("mysql_error()");
	if ($res==null) return $def;
	if (mysql_num_rows($res) >0) $r=mysql_result($res,0,0); else $r=$def;
	mysql_free_result($res);
	
	return $r;
}

function dlookup_row($q)
{
	$res=mysql_query($q) or print("mysql_error()");
	if ($res==null) return null;
	if (mysql_num_rows($res) >0) $r=mysql_fetch_assoc($res); else $r=null;
	mysql_free_result($res);
	return $r;
}
function d($s){return base64_decode($s);}
function dcount($q)
{
	$res=mysql_query($q);
	if ($res==null) return 0;
	if (mysql_num_rows($res) >0) $r=mysql_num_rows($res); else $r=0;
	mysql_free_result($res);
	return $r;
}

/* Check for valid email address */
function is_valid_email($email) {
	/* Credits: http://www.ilovejackdaniels.com/php/email-address-validation/ */

	if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {    
		return false;  
	}  
	$email_array = explode("@", $email);  
	$local_array = explode(".", $email_array[0]);  
	for ($i = 0; $i < sizeof($local_array); $i++) {     
		if (!ereg("^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[$i])) {      
			return false;    
		}  
	}    
	if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) { 
		$domain_array = explode(".", $email_array[1]);    
		if (sizeof($domain_array) < 2) {        
			return false; // Not enough parts to domain    
		}    
		for ($i = 0; $i < sizeof($domain_array); $i++) {      
			if (!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) {       
				return false;      
			}    
		}  
	} 
	return true;
} 

function addhyperlinks($text) {
    // match protocol://address/path/file.extension?some=variable&another=asf%
    $text = preg_replace("/\s([a-zA-Z]+:\/\/[a-z][a-z0-9\_\.\-]*[a-z]{2,6}[a-zA-Z0-9\/\*\.\-\?\&\%]*)([\s|\,])/i", " <a href=\"$1\" target=\"_blank\">$1</a>$2", " ".$text." ");
    // match www.something.domain/path/file.extension?some=variable&another=asf%
    $text = preg_replace("/\s(www\.[a-z][a-z0-9\_\.\-]*[a-z]{2,6}[a-zA-Z0-9\/\*\-\?\&\%\.]*)([\s|\,])/i", " <a href=\"http://$1\" target=\"_blank\">$1</a>$2", $text);
    // match name@address
    $text = preg_replace("/\s([a-zA-Z][a-zA-Z0-9\_\.\-]*[a-zA-Z]*\@[a-zA-Z][a-zA-Z0-9\_\.\-]*[a-zA-Z]{2,6})([\s|\.|\,])/i", " <a href=\"mailto://$1\">$1</a>$2", $text);
    // match [smile_image]
    $text = preg_replace_callback("/\[([a-zA-Z0-9\_\.\-]*)\]/i", create_function('$matches','if (!file_exists("ico/emoticon_".$matches[1].".gif")) return $matches[0]; else return " <img src=\"ico/emoticon_".$matches[1].".gif\"/>";'), $text);
    // match [img]
    $text= preg_replace_callback("/\[img\]([^\[]*)\[\/img\]/i", create_function('$matches','return " <img src=\"".((strpos($matches[1],"://")===false)?"http://":"")."".$matches[1]."\" />";'), $text);
	
    return $text;
}
function file_put_data($n,$d) {
 $f=@fopen($n,"w");
 if (!$f) {
   return false;
 } else {
   $bc=fwrite($f,$d);
   fclose($f);
   return $bc;
 }
}
function formatMinutes($m){
	return floor($m/60).":".sprintf("%02d",($m-((floor($m/60))*60)));
}

function list_article($url,$img,$title,$date1,$t1,$h1,$article,$permalink=""){
	global $sid,$uid,$time_format;
	?>
	<table class="contentpaneopen">
	<tr><td class="contentheading" style="cursor:pointer;" onclick="<?php echo $url?>">
		<?php if(strlen($permalink)){?><a onclick="return false;" style="text-decoration:none;" href="<?php echo $permalink?>"><?php }?>
			<img src="<?php echo $img?>"/> <?php echo $title?>
		<?php if(strlen($permalink)){?></a><?php }?>
	</td></tr>
	<tr><td><span class="small"><?php echo ((strlen($t1))?$t1.", ":"").date($time_format,strtotime2($date1));?></span></td></tr>
	<?php if(strlen($h1)){?><tr><td><p><?php echo $h1?></p></td></tr><?php }?>
	</table>
	<span class="article_separator"></span>
	<?php
}

function checkSID(){
	//free 	$_SESSION["sid"]='1';
	if (!isset($_REQUEST["site"]) && !isset($_SESSION["sid"])) {
		if(isset($_SERVER['HTTP_HOST'])){
			// get host name from URL
			preg_match('@^(?:http://)?([^\.]+)@i',$_SERVER['HTTP_HOST'], $matches);
			$sid=dlookup("sid","subdomains","name='$matches[0]'",null);
			if ($sid==null || !isset($sid)) $sid=dlookup("def_site","cfg","true");
		}
		else $sid=dlookup("def_site","cfg","true");
		$_SESSION["sid"]=$sid;
		if (strlen($sid)<1) die("Error: SITE request variable must be set.");
	}
	if (isset($_REQUEST["site"]) ) {
		if(isset($_SESSION["sid"]) && $_SESSION["sid"]!=$_REQUEST["site"]){unset($_SESSION["logged_in"]);}
		$_SESSION["sid"]=$_REQUEST["site"];
	}
}

function showLangSel(){
	global $sid;
	if(dlookup("show_lang","site","sid=$sid")){?>
		<select  name="lang_sel" id="lang_sel" onchange="window.location.href=('index.php?<?php if(isset($_REQUEST['a'])) echo "a=".$_REQUEST['a']."&";?>lang='+encodeURIComponent(elem('lang_sel').options[elem('lang_sel').selectedIndex].text));">
		<?php $x=getdir("lang/");
		foreach($x as $va){
			$v=$va["name"];
			$v=substr($v,5,strlen($v)-9);
			echo "<option value=\"$v\" ".(($v==$_SESSION["lang"])?"SELECTED":"").">".$v."</option>";
		}
		?>
		</select><?php
	}
}
function pathway($str){
	global $is_admin;
	if($_SESSION['bHasEXT']){?>
			<script>if(document.layout) document.layout.findById('center').setTitle('<?php echo addslashes($str)?>');</script>
	<?php }
	else if (isset($_SESSION["_VALID_MOS"]) && !$is_admin){
		?><script>if (document.getElementById('esp_pathway')) document.getElementById('esp_pathway').innerHTML='<?php echo addslashes($str)?>';</script><?php
	}
	else{
		?><h1><?php echo addslashes($str)?></h1><?php
	}
	return "";
}

function geticon($fn){
	$a=$fn;
	switch(strtolower(substr($a,-3))){
		case "jpg":case "gif":case "bmp":case "png":case "3gp":case "flv":case "avi":case "wmv":case "mpg":return "ico/picture.gif";
		case "zip":case "rar":case "arj":return "ico/page_zip.gif";
		case "ppt":case "mdb":case "xls":case "doc":case "txt":case "rtf":return "ico/page_office.gif";
		case "pdf":return "ico/page_pdf.gif";
	}
	return "ico/page_white.gif";
}

function formatTime($sec,$o=false){
	$sec=(int)$sec;
	$days=(int)($sec/(24*60*60));$sec-=($days*(24*3600));
	$h=(int)($sec/3600);$sec-=$h*3600;
	$m=(int)($sec/60);$sec-=$m*60;
	
	return (($days>0)?"$days days ":"").(($o && $days!=0)?"":((($h>0)?"$h hr ":"").(($m>0)?"$m min ":"$m min")));
}


function readOpts(){
	global $sid;
	
	//defaults
	$GLOBALS['optListSubItems']=1;
	$GLOBALS['optColumnCount']=1;
	$GLOBALS['optRightSide']=1;
	$GLOBALS['optPermalink']=1;
	$GLOBALS['optWH']=str_repeat('1',7*24);
	
	$a=dlookup("opts","site","sid=$sid");
	$p=explode(";",$a);
	foreach($p as $v){
		$b=explode("=",$v);
		$GLOBALS[$b[0]]=$b[1];
	}
}

function escalateSLA(){
	global $sid;
	//escalate / notify tickets by SLA rules
	$res = mysql_query("select * from reg,sla where reg.sid=$sid and sla.sid=$sid and reg.sla_id=sla.id and cur_status<5 and due_to>0 and (escalated1=0 or escalated2=0 or notified=0)") or die("mysql_error()");
	while($row = mysql_fetch_assoc($res)){
		if(strlen($row['escalate_before_to']) && !$row['escalated1'] && strtotime($row['due_to'])-3600*$row['escalate_before']<time()) {
			//escalate1
			$n=dlookup("name","usr","sid=$sid and uname='".$row['escalate_before_to']."'",$row['escalate_before_to']);
			if (strlen($row['assigned_to']) && $row['assigned_to']!=$row['escalate_before_to'])
				mysql_query("insert into notifications(sid,uid_from,uid_to,tt,txt,active) values($sid,'SYSTEM','".$row['assigned_to']."',now(),'ticket ".$row['ID']." escalated from you ".$row['escalate_before']." hours before a deadline',1)") or die("mysql_error()");
			mysql_query("insert into notifications(sid,uid_from,uid_to,tt,txt,active) values($sid,'SYSTEM','".$row['escalate_before_to']."',now(),'ticket ".$row['ID']." escalated to you ".$row['escalate_before']." hours before a deadline',1)") or die("mysql_error()");
			
			$addr=dlookup("addr","usr","sid=$sid and uname='".$row['escalate_before_to']."'");
			$txt="Ticket ID: ".$row['ID']."<br>Subject: ".$row['subject']."<br>Sender: ".$row['uid']."<br>Time:".$row['time1']."<br>Assigned to: ".$row['assigned_to'];
			if ($addr!=null) send_mail($addr,"ticket ".$row['ID']." escalated to you ".$row['escalate_before']." hours before a deadline",$txt);
			
			mysql_query("update reg set time2=now(),escalated1=1,assigned_to='".$row['escalate_before_to']."' where sid=$sid and ID='".$row['ID']."'");
			mysql_query("insert into reg_log(sid,tid,uid,note,time1,private,time_spent) values($sid,'".$row['ID']."','SYSTEM','escalated to $n',NOW(),1,0)");
		}
		if(strlen($row['escalate_after_to']) && !$row['escalated2'] && strtotime($row['due_to'])+3600*$row['escalate_after']<time()) {
			//escalate2
			$n=dlookup("name","usr","sid=$sid and uname='".$row['escalate_after_to']."'",$row['escalate_after_to']);
			if (strlen($row['assigned_to']) && $row['assigned_to']!=$row['escalate_after_to'])
				mysql_query("insert into notifications(sid,uid_from,uid_to,tt,txt,active) values($sid,'SYSTEM','".$row['assigned_to']."',now(),'ticket ".$row['ID']." escalated from you ".$row['escalate_after']." hours after a deadline',1)") or die("mysql_error()");
			mysql_query("insert into notifications(sid,uid_from,uid_to,tt,txt,active) values($sid,'SYSTEM','".$row['escalate_after_to']."',now(),'ticket ".$row['ID']." escalated to you ".$row['escalate_after']." hours after a deadline',1)");
			mysql_query("update reg set time2=now(),escalated2=1,assigned_to='".$row['escalate_after_to']."' where sid=$sid and ID='".$row['ID']."'");

			$addr=dlookup("addr","usr","sid=$sid and uname='".$row['escalate_after_to']."'");
			$txt="Ticket ID: ".$row['ID']."<br>Subject: ".$row['subject']."<br>Sender: ".$row['uid']."<br>Time:".$row['time1']."<br>Assigned to: ".$row['assigned_to'];
			if ($addr!=null) send_mail($addr,"ticket ".$row['ID']." escalated to you ".$row['escalate_before']." hours after a deadline",$txt);

			mysql_query("insert into reg_log(sid,tid,uid,note,time1,private,time_spent) values($sid,'".$row['ID']."','SYSTEM','escalated to $n',NOW(),1,0)");
		}
		if(strlen($row['notify']) && !$row['notified'] && strtotime($row['due_to'])<time() && $row['cur_status']<4) {//don't overdue 'waiting' tickets
			//notify deadline
			mysql_query("insert into notifications(sid,uid_from,uid_to,tt,txt,active) values($sid,'SYSTEM','".$row['notify']."',now(),'ticket ".$row['ID']." overdue',1)");
			mysql_query("update reg set notified=1 where sid=$sid and ID='".$row['ID']."'");
			
			$addr=dlookup("addr","usr","sid=$sid and uname='".$row['notify']."'");
			$txt="Ticket ID: ".$row['ID']."<br>Subject: ".$row['subject']."<br>Sender: ".$row['uid']."<br>Time:".$row['time1']."<br>Assigned to: ".$row['assigned_to'];
			if ($addr!=null) send_mail($addr,"ticket ".$row['ID']." overdue",$txt);
		}
	}
	mysql_free_result($res);
}

function add_gl($a){
	global $sid;
	$c=1;
	$res = mysql_query("select * from gl where sid=$sid");
	while($row = mysql_fetch_assoc($res)) {
		foreach(array('w','a1','a2','a3') as $f){
			if(strlen($row[$f])){
				$replace = '\\1<span style="font-style:italic;border-bottom:solid blue 1px;" onmouseout="elem(\'_gl_def'.$c.'\').style.display=\'none\';" onmouseover="elem(\'_gl_def'.$c.'\').style.display=\'inline\';re_position(elem(\'_gl_def'.$c.'\'));">\\2</span><span style="position:absolute;display:none;border:solid gray 1px;background:#ffa;font-size:7pt;line-height:8pt;padding:5px;" id="_gl_def'.$c.'">'.$row['def1'].'</span>\\3';
				$a=eregi_replace('([^a-z0-9])('. $row[$f].')([^a-z0-9])', $replace, $a);
				$c++;
			}
		}
	}
	mysql_free_result($res);
	return $a;
}

function group_cn($_conn,$_base_dn,$gid){
	// coping with AD not returning the primary group
	// http://support.microsoft.com/?kbid=321360
	// for some reason it's not possible to search on primarygrouptoken=XXX
	// if someone can show otherwise, I'd like to know about it :)
	// this way is resource intensive and generally a pain in the @#%^
	
	if ($gid==NULL){ return (false); }
	$r=false;
	
	$filter="(&(objectCategory=group)(samaccounttype=268435456))";
	$fields=array("primarygrouptoken","samaccountname","distinguishedname");
	$sr=ldap_search($_conn,$_base_dn,$filter,$fields);
	$entries = ldap_get_entries($_conn, $sr);
	
	for ($i=0; $i<$entries["count"]; $i++){
		if ($entries[$i]["primarygrouptoken"][0]==$gid){
			$r=$entries[$i]["distinguishedname"][0];
			$i=$entries["count"];
		}
	}

	$bits=explode(",",$r);
	$group_array[]=substr($bits[0],3,(strlen($bits[0])-3));
	
	return ($group_array[0]);
}

function ldap_check($user,$pwd){
	global $sid;
	
	$site=dlookup_row("select * from site where sid=$sid");

	if(!function_exists('ldap_connect')) return false;
	if(!strlen($site['ldap_host'])) return false;
	
	$ds=ldap_connect($site['ldap_host']);
	if ($ds!==FALSE) {
		$rdn="cn=$user, ".$site['ldap_baseDN'];$ad=false;
		if(substr($site['ldap_baseDN'],0,1)=='@') {$ad=true;$rdn=$user.$site['ldap_baseDN'];} //Active Directory
		ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
		ldap_set_option($ds, LDAP_OPT_REFERRALS, 0);
		$r=ldap_bind($ds,$rdn, $pwd);

		{
			if($ad) {
				$_base_dn="dc=".str_replace(".",",dc=",substr($site['ldap_baseDN'],1));
				$sr = ldap_search($ds, $_base_dn,"(samaccountname=$user)");
			}
			else {
				$_base_dn=$site['ldap_baseDN'];
				$sr = ldap_search($ds, $_base_dn,"(uid=$user)");
			}
			$entry = ldap_first_entry($ds, $sr);
			
			/*{
				$ai=ldap_first_attribute($ds,$entry,$a2);
				$a=ldap_get_values($ds,$entry,$ai);$ai.="=".$a[0]."\n";
				while(($i=ldap_next_attribute($ds,$entry,$a2))!=FALSE) {
					$a=ldap_get_values($ds,$entry,$i);
					$ai.=$i."=".$a[0]."\n";
				}
			}*/
			
			
			
			$a=ldap_get_values($ds,$entry,"mail");$mail=$a[0];
			$a=ldap_get_values($ds,$entry,"givenname");$name=$a[0];
			
			if($ad){
				$a=ldap_get_values($ds,$entry,"memberof");
				if(strlen($a[0])){
					$bits=explode(",",$a[0]);
					$group_array[]=substr($bits[0],3,(strlen($bits[0])-3));
					$ou=$group_array[0];
				}
				else{
					$a=ldap_get_values($ds,$entry,"primarygroupid");
					if ($a[0]=='513') $ou="Domain Users"; else $ou=group_cn($ds,$_base_dn,$a[0]);
				}
			}
			else{
				$a=ldap_get_values($ds,$entry,"ou");$ou=$a[0];
			}
			
			
			$a=ldap_get_values($ds,$entry,"sn");$name.=" ".$a[0];
			
		}
		ldap_close($ds);
		if ($r) return array('uid'=>$user,'name'=>$name,'mail'=>$mail,'ou'=>$ou,'all'=>$ai);
	}
	else print ldap_error($ds);
	return false;
}
/*
SELECT id, count( * ) as search_rank
FROM (
		SELECT id FROM kb WHERE article LIKE '%set%'
	UNION ALL 
		SELECT id FROM kb WHERE article LIKE '%auto%'
) AS search_list0
GROUP BY id
ORDER BY count( * ) DESC 
*/
function generateSearchSQL($id,$table,$where,$search_fields, $search_term){
	$st=explode(" ",$search_term);
	if(!is_array($search_fields)) $search_fields=explode(",",$search_fields);
	if($where!="") $where.=" and ";

	foreach($st as $st1){
		foreach($search_fields as $sf1){
			if(strlen($sql)>0) $sql.=" union all ";
			$sql.="select `$id` from `$table` where $where `$sf1` like '%$st1%' \n";
		}
	}

	if(strlen($sql))
		$sql="select `$id`,count(*) as search_rank from ($sql) as search_list0 group by `$id` order by `search_rank` desc";
	else{
		if($where=="") $where="1=1";
		$sql="select `$id`,1 as search_rank from `$table` where $where";
	}
	return $sql;
}


function utf2html($string) { 
      /* Only do the slow convert if there are 8-bit characters */ 
    /* avoid using 0xA0 (\240) in ereg ranges. RH73 does not like that */ 
    if (! ereg("[\200-\237]", $string) and ! ereg("[\241-\377]", $string)) 
        return $string; 

    // decode three byte unicode characters 
    $string = preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e",        
    "'&#'.((ord('\\1')-224)*4096 + (ord('\\2')-128)*64 + (ord('\\3')-128)).';'",    
    $string); 

    // decode two byte unicode characters 
    $string = preg_replace("/([\300-\337])([\200-\277])/e", 
    "'&#'.((ord('\\1')-192)*64+(ord('\\2')-128)).';'", 
    $string); 

    return $string; 
} 


function utf2html_old($s){
	$r="";
	for($i=0;$i<strlen($s);$i++){
		if(ord($s[$i])>127) {$r.="&#".uniord($s[$i].$s[$i+1]).";";$i++;}
		else $r.=$s[$i];
	}
	return $r;
}
function uniord($c) {
	$ud = 0;
	if (ord($c{0}) >= 0 && ord($c{0}) <= 127) $ud = ord($c{0});
	if (ord($c{0}) >= 192 && ord($c{0}) <= 223) $ud = (ord($c{0})-192)*64 + (ord($c{1})-128);
	if (ord($c{0}) >= 224 && ord($c{0}) <= 239) $ud = (ord($c{0})-224)*4096 + (ord($c{1})-128)*64 + (ord($c{2})-128);
	if (ord($c{0}) >= 240 && ord($c{0}) <= 247) $ud = (ord($c{0})-240)*262144 + (ord($c{1})-128)*4096 + (ord($c{2})-128)*64 + (ord($c{3})-128);
	if (ord($c{0}) >= 248 && ord($c{0}) <= 251) $ud = (ord($c{0})-248)*16777216 + (ord($c{1})-128)*262144 + (ord($c{2})-128)*4096 + (ord($c{3})-128)*64 + (ord($c{4})-128);
	if (ord($c{0}) >= 252 && ord($c{0}) <= 253) $ud = (ord($c{0})-252)*1073741824 + (ord($c{1})-128)*16777216 + (ord($c{2})-128)*262144 + (ord($c{3})-128)*4096 + (ord($c{4})-128)*64 + (ord($c{5})-128);
	if (ord($c{0}) >= 254 && ord($c{0}) <= 255) $ud = false; // error
	return $ud;
  }

function _unhtmlentities($string) {
	$string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
	$string = preg_replace('~&#([0-9]+);~e', 'chr(\\1)', $string);

	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);

	return strtr($string, $trans_tbl);
}

function charset_decode_utf_8 ($string) { 
      /* Only do the slow convert if there are 8-bit characters */ 
    /* avoid using 0xA0 (\240) in ereg ranges. RH73 does not like that */ 
    if (! ereg("[\200-\237]", $string) and ! ereg("[\241-\377]", $string)) 
        return $string; 

    // decode three byte unicode characters 
    $string = preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e",        
    "'&#'.((ord('\\1')-224)*4096 + (ord('\\2')-128)*64 + (ord('\\3')-128)).';'",    
    $string); 

    // decode two byte unicode characters 
    $string = preg_replace("/([\300-\337])([\200-\277])/e", 
    "'&#'.((ord('\\1')-192)*64+(ord('\\2')-128)).';'", 
    $string); 

    return $string; 
} 
function nl2br2($string) {
	$string = str_replace(array("\r\n", "\r", "\n"), "<br />", $string);
	return $string;
}

?>